#  ICBM ollexxl@live.se 20130507-
# v. 1
# ICBM in its basic differential equation form
# No driving variables, just parameters 
# Parameters: Steady state from Andrn et al., 1997

# Parameters & state equations, see also www.oandren.com
# Change i, re and h and set inital Y and O
getwd() #Work dir
re <- 1.0 ; i <- 0.2 ; kY <- 0.8 ; kO <- 0.00605 ; h <- 0.125
Y0 <- 0.25 ; O0 <- 4.16 ; time <- 0:30 # 30 yrs - can be changed
Oss <- (h*i)/(re*kO) ; Yss <- i/(re*kY)

comment(Oss) <- c("This is the old (O) carbon mass at steady state",
"2013-05-08 Lanzhou")
comment(Yss) <- c("This is the young (Y) carbon mass at steady state")
Oss
comment(Oss)
Yss
comment(Yss)

# Y differential equation integral form
Y <- i/(kY*re) + (Y0-i/(kY*re))*exp(-kY*re*time)
# O corresponding 
O <- (O0 - i*kY*h*re/(kY*re*kO*re) - kY*h*re*Y0/(kO*re-kY*re) + i*kY*h*re/(kY*re*(kO*re-kY*re)))*exp(-kO*re*time) + i*kY*h*re/(kY*re*kO*re) + (kY*h*re*Y0/(kO*re-kY*re))*exp(-kY*re*time) - (i*kY*h*re/(kY*re*(kO*re-kY)))*exp(-kY*re*time)
Tot <- Y+O
#plot (time,Y)
# plot (time, O)
plot (time, Tot, type='l', main = bquote(ICBM~ "re ="~.(re)),xlab='Time (years)',ylab='Mass (g)',
yaxs='i',sub=bquote("i ="~.(i)),col='red',lwd='3',ylim=c(0,10), yaxp=c(0,10,10))
lines (time, O, type='l',col='blue')
 
legend("topleft", legend=c("Tot", "O"), 
text.col=c('red','blue'),ncol=2)
 
#cbind makes a matrix out of the variable vectors for printing etc
outall=cbind(time,O,Y,Tot,re,i,kY,kO,h,Y0,O0,Oss,Yss)

print.default(outall)

#export text file to be able to read into e.g. Excel
write.table(outall,file="C:/Users/Olle/Skydrive/rtest/test3.txt")


